## maliit-keyboard 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(maliit-keyboard VERSION 2.1.0)

option(enable-presage "Use presage to calculate word candidates (maliit-keyboard-plugin only)" ON)
option(enable-hunspell "Use hunspell for error correction (maliit-keyboard-plugin only)" ON)
option(enable-tests "Build tests" OFF)

# Install paths
include(GNUInstallDirs)

if(NOT DEFINED QT5_QML_INSTALL_DIR)
    set(QT5_QML_INSTALL_DIR "${LIB_INSTALL_DIR}/qt5/qml" CACHE PATH
            "Installation directory for Qt 5 QML plugins [LIB_INSTALL_DIR/qt5/qml]")
endif()

set(HUNSPELL_DICT_PATH "/usr/share/hunspell" CACHE PATH "Directory containing hunspell dictionary files")
set(MALIIT_KEYBOARD_QML_DIR "${CMAKE_INSTALL_LIBDIR}/maliit/keyboard2/qml" CACHE PATH "Directory containing maliit-keyboard QML files")
set(MALIIT_KEYBOARD_DATA_DIR "${CMAKE_INSTALL_DATADIR}/maliit/keyboard2" CACHE PATH "Directory containing maliit-keyboard data files")
set(MALIIT_KEYBOARD_LANGUAGES_DIR "${CMAKE_INSTALL_LIBDIR}/maliit/keyboard2/languages" CACHE PATH "Directory containing maliit-keyboard data")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

find_package(MaliitPlugins 0.99.1 REQUIRED)

find_package(GLib2 REQUIRED)
find_package(GIO REQUIRED)

find_package(Qt5DBus)

find_package(Qt5Multimedia)
find_package(Qt5Feedback)
find_package(Intl REQUIRED)

find_package(Anthy)
find_package(Pinyin)
find_package(Chewing)

set(MALIIT_KEYBOARD_LIB_SOURCES
        src/lib/logic/abstractlanguagefeatures.h
        src/lib/logic/abstractlanguageplugin.cpp
        src/lib/logic/abstractlanguageplugin.h
        src/lib/logic/abstractwordengine.cpp
        src/lib/logic/abstractwordengine.h
        src/lib/logic/eventhandler.cpp
        src/lib/logic/eventhandler.h
        src/lib/logic/languageplugininterface.h
        src/lib/logic/wordengine.cpp
        src/lib/logic/wordengine.h

        src/lib/models/area.cpp
        src/lib/models/area.h
        src/lib/models/key.cpp
        src/lib/models/key.h
        src/lib/models/keyarea.cpp
        src/lib/models/keyarea.h
        src/lib/models/keyboard.h
        src/lib/models/keydescription.h
        src/lib/models/layout.cpp
        src/lib/models/layout.h
        src/lib/models/text.cpp
        src/lib/models/text.h
        src/lib/models/wordcandidate.cpp
        src/lib/models/wordcandidate.h
        src/lib/models/wordribbon.cpp
        src/lib/models/wordribbon.h

        src/lib/coreutils.cpp
        src/lib/coreutils.h)

set(WESTERNSUPPORT_SOURCES
        plugins/westernsupport/spellchecker.cpp
        plugins/westernsupport/spellchecker.h
        plugins/westernsupport/westernlanguagefeatures.cpp
        plugins/westernsupport/westernlanguagefeatures.h
        plugins/westernsupport/westernlanguagesplugin.cpp
        plugins/westernsupport/westernlanguagesplugin.h
        plugins/westernsupport/westernsupport.cpp
        plugins/westernsupport/westernsupport.h
        plugins/westernsupport/westernsupport_global.h)

# TODO install logic/languageplugininterface.h and logic/abstractplugininterface.h as HEADERS

set(maliit-keyboard-libraries Qt5::Core)
set(maliit-keyboard-definitions HUNSPELL_DICT_PATH="${HUNSPELL_DICT_PATH}"
        MALIIT_GETTEXT_PACKAGE="${PROJECT_NAME}"
        MALIIT_LOCALE_DIR="${CMAKE_INSTALL_LOCALEDIR}/locale"
        MALIIT_PLUGINS_DATA_DIR="${CMAKE_INSTALL_PREFIX}/${MALIIT_PLUGINS_DATA_DIR}"
        MALIIT_KEYBOARD_QML_DIR="${CMAKE_INSTALL_PREFIX}/${MALIIT_KEYBOARD_QML_DIR}"
        MALIIT_KEYBOARD_DATA_DIR="${CMAKE_INSTALL_PREFIX}/${MALIIT_KEYBOARD_DATA_DIR}"
        MALIIT_KEYBOARD_LANGUAGES_DIR="${CMAKE_INSTALL_PREFIX}/${MALIIT_KEYBOARD_LANGUAGES_DIR}")
set(maliit-keyboard-include-dirs)

if(enable-presage)
    # Presage headers incompatible with C++17, which is default in newer GCC
    set(CMAKE_CXX_STANDARD 14)
    find_package(Presage REQUIRED)

    if(Presage_FOUND)
        list(APPEND maliit-keyboard-definitions HAVE_PRESAGE)
        list(APPEND maliit-keyboard-libraries ${Presage_LIBRARIES})
        list(APPEND maliit-keyboard-include-dirs ${Presage_INCLUDE_DIRS})

        list(APPEND WESTERNSUPPORT_SOURCES
                plugins/westernsupport/candidatescallback.cpp
                plugins/westernsupport/candidatescallback.h
                plugins/westernsupport/spellpredictworker.cpp
                plugins/westernsupport/spellpredictworker.h)
    endif()
endif()

if(enable-hunspell)
    find_package(Hunspell REQUIRED)
    list(APPEND maliit-keyboard-definitions HAVE_HUNSPELL)
    list(APPEND maliit-keyboard-libraries ${Hunspell_LIBRARIES})
    list(APPEND maliit-keyboard-include-dirs ${Hunspell_INCLUDE_DIRS})
endif()

add_library(maliit-keyboard-lib STATIC ${MALIIT_KEYBOARD_LIB_SOURCES})
target_link_libraries(maliit-keyboard-lib Qt5::Core Maliit::Plugins)
target_include_directories(maliit-keyboard-lib PUBLIC src/lib)
target_compile_definitions(maliit-keyboard-lib PRIVATE ${maliit-keyboard-definitions})

set(MALIIT_KEYBOARD_VIEW_SOURCES
        src/view/abstracttexteditor.cpp
        src/view/abstracttexteditor.h
        src/view/setup.cpp
        src/view/setup.h)

add_library(maliit-keyboard-view STATIC ${MALIIT_KEYBOARD_VIEW_SOURCES})
target_link_libraries(maliit-keyboard-view Maliit::Plugins maliit-keyboard-lib)
target_include_directories(maliit-keyboard-view PUBLIC src)

set(QGSETTINGS_SOURCES
        src/3rdparty/QGSettings/qconftypes.cpp
        src/3rdparty/QGSettings/qconftypes.h
        src/3rdparty/QGSettings/QGSettings
        src/3rdparty/QGSettings/qgsettings.cpp
        src/3rdparty/QGSettings/qgsettings.h
        src/3rdparty/QGSettings/util.cpp
        src/3rdparty/QGSettings/util.h)

add_library(gsettings-qt STATIC ${QGSETTINGS_SOURCES})
target_link_libraries(gsettings-qt Qt5::Core ${GIO_LIBRARIES})
target_include_directories(gsettings-qt PUBLIC ${GIO_INCLUDE_DIRS} src/3rdparty)
target_compile_definitions(gsettings-qt PRIVATE -DQT_NO_KEYWORDS)

set(MALIIT_KEYBOARD_COMMON_SOURCES
        src/plugin/editor.cpp
        src/plugin/editor.h
        src/plugin/feedback.cpp
        src/plugin/feedback.h
        src/plugin/gettext.cpp
        src/plugin/gettext.h
        src/plugin/greeterstatus.cpp
        src/plugin/greeterstatus.h
        src/plugin/updatenotifier.cpp
        src/plugin/updatenotifier.h
        src/plugin/iconprovider.cpp
        src/plugin/iconprovider.h
        src/plugin/inputmethod.cpp
        src/plugin/inputmethod.h
        src/plugin/inputmethod_p.h
        src/plugin/keyboardgeometry.cpp
        src/plugin/keyboardgeometry.h
        src/plugin/keyboardsettings.cpp
        src/plugin/keyboardsettings.h
        src/plugin/theme.cpp src/plugin/theme.h src/plugin/device.cpp src/plugin/device.h)

add_library(maliit-keyboard-common STATIC ${MALIIT_KEYBOARD_COMMON_SOURCES})
target_link_libraries(maliit-keyboard-common Qt5::DBus Maliit::Plugins maliit-keyboard-lib maliit-keyboard-view gsettings-qt Qt5::Multimedia ${Intl_LIBRARIES})
if (Qt5Feedback_FOUND)
    target_link_libraries(maliit-keyboard-common Qt5::Feedback)
    target_compile_definitions(maliit-keyboard-common PUBLIC HAVE_QT5_FEEDBACK)
endif()
target_compile_definitions(maliit-keyboard-common PRIVATE ${maliit-keyboard-definitions})
target_compile_features(maliit-keyboard-common PRIVATE cxx_std_17)

set(MALIIT_KEYBOARD_PLUGIN_SOURCES
        src/plugin/plugin.cpp
        src/plugin/plugin.h
        src/plugin/plugin.json)

add_library(maliit-keyboard-plugin MODULE ${MALIIT_KEYBOARD_PLUGIN_SOURCES})
target_link_libraries(maliit-keyboard-plugin maliit-keyboard-common)
target_compile_definitions(maliit-keyboard-plugin PRIVATE ${maliit-keyboard-definitions})

set(MALIIT_KEYBOARD_SOURCES
        src/plugin/plugin.cpp
        src/plugin/plugin.h
        src/keyboard/keyboard.cpp)

add_executable(maliit-keyboard ${MALIIT_KEYBOARD_SOURCES})
target_link_libraries(maliit-keyboard maliit-keyboard-common)
target_compile_definitions(maliit-keyboard PRIVATE ${maliit-keyboard-definitions})

# TODO install westernlanguagesplugin.h into "$${MALIIT_PLUGINS_DATA_DIR}/com/ubuntu/include"

add_library(westernsupport STATIC ${WESTERNSUPPORT_SOURCES})
target_link_libraries(westernsupport ${maliit-keyboard-libraries} Maliit::Plugins)
target_include_directories(westernsupport PUBLIC src/lib/logic plugins/westernsupport ${maliit-keyboard-include-dirs})
target_compile_definitions(westernsupport PRIVATE ${maliit-keyboard-definitions})

function(language_plugin _language _full_language _ebook)
    # To support layout style variations such as en@dv we need to avoid using
    # the @ character in variables, so split and replace it with _
    set(_target ${_language})
    if(${_language} MATCHES "^(.*)\@(.*)$")
        set(_target ${CMAKE_MATCH_1}_${CMAKE_MATCH_2})
    endif()

    set(PLUGIN_SOURCES
            plugins/${_language}/src/${_full_language}plugin.h
            plugins/${_language}/src/${_full_language}plugin.json)
if(enable-presage)
    add_ngram(TEXT plugins/${_language}/src/${_ebook} DATABASE database_${_language}.db)
    list(APPEND PLUGIN_SOURCES database_${_language}.db)
endif()
    add_library(${_target}plugin MODULE ${PLUGIN_SOURCES})
    set_target_properties(${_target}plugin PROPERTIES OUTPUT_NAME ${_language}plugin)
    target_link_libraries(${_target}plugin maliit-keyboard-common westernsupport)
    install(FILES plugins/${_language}/qml/Keyboard_${_language}.qml
            plugins/${_language}/qml/Keyboard_${_language}_email.qml
            plugins/${_language}/qml/Keyboard_${_language}_url.qml
            plugins/${_language}/qml/Keyboard_${_language}_url_search.qml
            DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
    install(TARGETS ${_target}plugin
            LIBRARY DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
if(enable-presage)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/database_${_language}.db
            DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
endif()
    foreach(_file IN LISTS ARGN)
        install(FILES plugins/${_language}/${_file}
                DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
    endforeach()
endfunction()

function(abstract_language_plugin _language _full_language)
    set(options ABSTRACT_LANGUAGE_PLUGIN)
    set(oneValueArgs NGRAM_DATABASE PLUGIN_DIR LANGUAGE_FEATURES)
    set(multiValueArgs SOURCES LIBRARIES INCLUDE_DIRS DEFINITIONS FILES DIRECTORY)
    cmake_parse_arguments(abstract_language_plugin "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

    # To support layout style variations such as en@dv we need to avoid using
    # the @ character in variables, so split and replace it with _
    set(_target ${_language})
    if(${_language} MATCHES "^(.*)\@(.*)$")
        set(_target ${CMAKE_MATCH_1}_${CMAKE_MATCH_2})
    endif()

    set(_plugindir ${_language})
    if(NOT ${abstract_language_plugin_PLUGIN_DIR} EQUAL "")
        set(_plugindir ${abstract_language_plugin_PLUGIN_DIR})
    endif()
    set(PLUGIN_SOURCES
            plugins/${_plugindir}/src/${_full_language}plugin.h
            plugins/${_plugindir}/src/${_full_language}plugin.json)
    if(EXISTS ${CMAKE_SOURCE_DIR}/plugins/${_plugindir}/src/${_full_language}plugin.cpp)
        list(APPEND PLUGIN_SOURCES
            plugins/${_plugindir}/src/${_full_language}plugin.cpp)
    endif()
    if(NOT ${abstract_language_plugin_LANGUAGE_FEATURES} EQUAL "")
        list(APPEND PLUGIN_SOURCES
                plugins/${_plugindir}/src/${abstract_language_plugin_LANGUAGE_FEATURES}languagefeatures.cpp
                plugins/${_plugindir}/src/${abstract_language_plugin_LANGUAGE_FEATURES}languagefeatures.h)
    elseif(EXISTS ${CMAKE_SOURCE_DIR}/plugins/${_plugindir}/src/${_full_language}languagefeatures.cpp)
        list(APPEND PLUGIN_SOURCES
                plugins/${_plugindir}/src/${_full_language}languagefeatures.cpp
                plugins/${_plugindir}/src/${_full_language}languagefeatures.h)
    endif()

=== debian/changelog ===
maliit-keyboard (2.2.0-1) unstable; urgency=medium

  [ Norbert Preining ]
  * Prepare initial packaging of v2.0.0.

  [ Mike Gabriel ]
  * Initial upload to Debian. (Closes: #991529).
  * debian/:
    + Move packaging over to the UBports Team's umbrella.
  * debian/patches:
    + Add README file explaining our patch naming scheme.
    + Add 1001_typo-fix-in-API.patch. Fix spelling error in API/ABI relevant
      parts of the code.
  * debian/control:
    + Improve SYNOPSIS and LONG_DESCRIPTION.
    + Bump Standards-Version: to 4.6.0. No changes needed.
    + Adjust Vcs-*: fields. Plan is to (co-)maintain the src:pkg with the
      Qt/KDE team in group Debian on salsa.debian.org.
    + Switch from Priority: extra to Priority: optional.
    + Set Section: field to 'x11' (we should actually have a 'graphical'
      section or somesuch).
  * debian/rules:
    + Add get-orig-source target (for the maintainer's convenience).
    + Drop DEB_LDFLAGS_MAIN_APPEND variable.
    + Enable all hardening build flags.
    + Remove extra license files from bin:pkg.
  * debian/{control,rules}:
    + Make preparations for enabling unit tests (once the issue has been
      resolved upstream).
  * debian/upstream/metadata:
    + Add file. Comply with DEP-12.
  * debian/source/lintian-overrides:
    + Override complains about emoji.js. The file is ok.
  * debian/copyright:
    + Add auto-generated copyright.in file.
    + Drop some very long lines from this file, manually.
    + Rewrite entire file.
  * debian/source/lintian-overrides:
    + Ignore long lines in COPYING.BSD.
    + Silence various reports about language-specific files with very long
      lines.
  * debian/maliit-keyboard.lintian-overrides:
    + Ignore missing man page for now, reported upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 07 Mar 2022 11:43:11 +0100

=== debian/control ===
Source: maliit-keyboard
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               libanthyinput-dev,
               libchewing3-dev,
               libhunspell-dev,
               libpinyin-common-dev,
               libpinyin13-dev,
               libpresage-dev,
               maliit-framework-dev,
               qtdeclarative5-dev,
               qtfeedback5-dev,
               qtmultimedia5-dev,
               sqlite3,
               presage,
               xauth,
               xvfb,
Standards-Version: 4.6.0
Homepage: https://github.com/maliit/keyboard
Vcs-Browser: https://salsa.debian.org/debian/maliit-keyboard
Vcs-Git: https://salsa.debian.org/debian/maliit-keyboard.git
Rules-Requires-Root: no

Package: maliit-keyboard
Architecture: any
Depends: maliit-framework, ${misc:Depends}, ${shlibs:Depends}
Description: virtual on-screen keyboard based on the Maliit Framework
 Maliit Keyboard is a virtual keyboard for Linux systems with Wayland and
 X11 display servers. It supports many different languages and emoji. It
 is implemented as a plug-in for Maliit Framework.
 .
 Maliit Keyboard evolved from the reference keyboard plug-in, Ubuntu
 Keyboard and Lomiri Keyboard. Ubuntu Keyboard was a fork of the
 reference plugin which was taking into account the special UI/UX needs
 of Ubuntu Phone.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

### https://github.com/maliit/keyboard/issues/7 (tests cannot be built)
#override_dh_auto_configure:
#	dh_auto_configure -- -Denable-tests=ON

override_dh_install:
	# drop extra license files from bin:pkg
	rm debian/maliit-keyboard/usr/share/doc/maliit-keyboard/COPYING*

	# finally, run dh_install
	dh_install

### https://github.com/maliit/keyboard/issues/7 (tests cannot be built)
#override_dh_auto_test:
#	xvfb-run dh_auto_test

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## maliit-keyboard 2.2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.9)
 
-project(maliit-keyboard VERSION 2.1.0)
+project(maliit-keyboard VERSION 2.2.1.1)
 
 option(enable-presage "Use presage to calculate word candidates (maliit-keyboard-plugin only)" ON)
 option(enable-hunspell "Use hunspell for error correction (maliit-keyboard-plugin only)" ON)
@@ -35,6 +35,7 @@
 find_package(Qt5Feedback)
 find_package(Intl REQUIRED)
 
+find_package(AnthyUnicode)
 find_package(Anthy)
 find_package(Pinyin)
 find_package(Chewing)
@@ -271,4 +272,3 @@
         list(APPEND PLUGIN_SOURCES
                 plugins/${_plugindir}/src/${_full_language}languagefeatures.cpp
                 plugins/${_plugindir}/src/${_full_language}languagefeatures.h)
-    endif()

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
                libpinyin13-dev,
                libpresage-dev,
                maliit-framework-dev,
+               qml-module-qtquick2,
                qtdeclarative5-dev,
                qtfeedback5-dev,
                qtmultimedia5-dev,

=== debian/watch ===
version=4
https://github.com/maliit/keyboard/releases /maliit/keyboard/archive/refs/tags/(\d\S*).tar.gz

## maliit-keyboard 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 cmake_minimum_required(VERSION 3.9)
 
-project(maliit-keyboard VERSION 2.2.1.1)
+project(maliit-keyboard VERSION 2.3.1)
 
 option(enable-presage "Use presage to calculate word candidates (maliit-keyboard-plugin only)" ON)
 option(enable-hunspell "Use hunspell for error correction (maliit-keyboard-plugin only)" ON)
-option(enable-tests "Build tests" OFF)
+option(enable-tests "Build tests" ON)
 
 # Install paths
 include(GNUInstallDirs)
@@ -31,6 +31,7 @@
 
 find_package(Qt5DBus)
 
+find_package(Qt5QuickControls2 REQUIRED)
 find_package(Qt5Multimedia)
 find_package(Qt5Feedback)
 find_package(Intl REQUIRED)
@@ -156,12 +157,8 @@
         src/plugin/feedback.h
         src/plugin/gettext.cpp
         src/plugin/gettext.h
-        src/plugin/greeterstatus.cpp
-        src/plugin/greeterstatus.h
         src/plugin/updatenotifier.cpp
         src/plugin/updatenotifier.h
-        src/plugin/iconprovider.cpp
-        src/plugin/iconprovider.h
         src/plugin/inputmethod.cpp
         src/plugin/inputmethod.h
         src/plugin/inputmethod_p.h
@@ -169,10 +166,11 @@
         src/plugin/keyboardgeometry.h
         src/plugin/keyboardsettings.cpp
         src/plugin/keyboardsettings.h
-        src/plugin/theme.cpp src/plugin/theme.h src/plugin/device.cpp src/plugin/device.h)
+        src/plugin/device.cpp
+        src/plugin/device.h)
 
 add_library(maliit-keyboard-common STATIC ${MALIIT_KEYBOARD_COMMON_SOURCES})
-target_link_libraries(maliit-keyboard-common Qt5::DBus Maliit::Plugins maliit-keyboard-lib maliit-keyboard-view gsettings-qt Qt5::Multimedia ${Intl_LIBRARIES})
+target_link_libraries(maliit-keyboard-common Qt5::DBus Qt5::QuickControls2 Maliit::Plugins maliit-keyboard-lib maliit-keyboard-view gsettings-qt Qt5::Multimedia ${Intl_LIBRARIES})
 if (Qt5Feedback_FOUND)
     target_link_libraries(maliit-keyboard-common Qt5::Feedback)
     target_compile_definitions(maliit-keyboard-common PUBLIC HAVE_QT5_FEEDBACK)
@@ -272,3 +270,6 @@
         list(APPEND PLUGIN_SOURCES
                 plugins/${_plugindir}/src/${_full_language}languagefeatures.cpp
                 plugins/${_plugindir}/src/${_full_language}languagefeatures.h)
+    endif()
+    if(abstract_language_plugin_ABSTRACT_LANGUAGE_PLUGIN)
+        list(APPEND PLUGIN_SOURCES

=== po/CMakeLists.txt ===
find_package(Gettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

file(GLOB_RECURSE I18N_SRC_FILES
     RELATIVE ${CMAKE_SOURCE_DIR}
     ${CMAKE_SOURCE_DIR}/qml/**.qml
     ${CMAKE_SOURCE_DIR}/qml/**.js
     ${CMAKE_SOURCE_DIR}/src/**.cpp
     ${CMAKE_SOURCE_DIR}/src/**.h)
list(SORT I18N_SRC_FILES)

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

add_custom_target(${POT_FILE}
                  COMMENT "Generating translation template"
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --c++ --qt --add-comments=TRANSLATORS
                          --keyword=qsTr --keyword=qsTr:1,2 --keyword=N_
                          --package-name='${DOMAIN}'
                          -D ${CMAKE_SOURCE_DIR} ${I18N_SRC_FILES}
                  COMMAND ${CMAKE_COMMAND} -E copy ${POT_FILE} ${CMAKE_CURRENT_SOURCE_DIR})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== debian/changelog ===
maliit-keyboard (2.3.1-6) unstable; urgency=medium

  [ Guido Berhoerster ]
  * debian/patches: Add
    + 2002_Revert-qml-Use-invisible-components-to-get-colors-fo.patch. Fix
      background color of key annotations.
      This reverts commit 3f0d076a6e55551760a27b994de8aff16e6c0d. This is a
      workaround until https://github.com/maliit/keyboard/issues/217 is
      addressed by upstream.

  [ Mike Gabriel ]
  * debian/patches:
    + Resort patch order.
    + Rebase patches after re-sorted patch order.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 27 May 2024 08:24:00 +0200

maliit-keyboard (2.3.1-5) unstable; urgency=medium

  * debian/patches:
    + Add 2001_use-noto-sans-font.patch. Enforce using Noto Sans for keyboard
      keys.
  * debian/control:
    + Add to D: field: fonts-noto, fonts-noto-color-emoji.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 29 Feb 2024 17:11:18 +0100

maliit-keyboard (2.3.1-4) unstable; urgency=medium

  * Revert "Remove unnecessary get-orig-source-target."
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
    + Add to R: various hunspell-<lang> packages.
  * debian/copyright:
    + Update copyright attribution for debian/.
  * debian/:
    + Re-add key_tick2_quiet.wav audio file back. It got removed from upstream,
      but is still referenced in the .gschema file. No adequate replacement in
      sight. So shipping the .wav file in the DEB package.
  * debian/source/lintian-overrides:
    + Drop doc/keyboard-styling-calc.ods from the list of files with too-long-
      line-length.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 04 Feb 2024 21:28:19 +0100

maliit-keyboard (2.3.1-3.1) unstable; urgency=medium

  * Non-maintainer upload

  [ Jelmer Vernooĳ ]
  * debian/rules:
    + Remove unnecessary get-orig-source-target.

  [ Gunnar Hjalmarsson ]
  * debian/control:
    + Build with libpinyin15-dev instead of libpinyin13-dev
      (closes: #1024593).

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Wed, 23 Nov 2022 10:09:39 +0100

maliit-keyboard (2.3.1-3) unstable; urgency=medium

  * debian/watch:
    + Adjust watch file to Github release/tag URLs.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 26 Oct 2022 21:08:06 +0200

maliit-keyboard (2.3.1-2) unstable; urgency=medium

  * debian/control:
    + Fix pkg:name in Depends: field. (Closes: #1022230).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 22 Oct 2022 13:11:48 +0200

maliit-keyboard (2.3.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop all pre-2.3.0 patches. Now included in this upstream release.
  * debian/control:
    + Add B-D: qtquickcontrols2-5-dev.
    + Bump Standards-Version: to 4.6.1. No changes needed.
    + Add D (maliit-keyboard): qml-module-qtquick2, qml-module-qtquick-
      controls2, qml-module-qtquick-qtgraphicaleffects and qml-module-
      qtquick-layouts.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * lintian: Update overrides for 2.115.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 10 Oct 2022 21:44:35 +0200

maliit-keyboard (2.2.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Add patches by Rodney Dawes to fix unit tests. (See:
      https://github.com/maliit/keyboard/pull/133).
  * debian/control:
    + Add to B-D: qml-model-qtquick2.
  * debian/rules:
    + Re-enable building and running unit tests.
  * debian/patches:
    + Drop 1001_typo-fix-in-API.patch again, applied upstream.
  * debian/copyright:
    + Update copyright attributions.
    + Update auto-generated copyright.in template file.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 25 Jun 2022 15:11:57 +0200

=== debian/control ===
--- 
+++ 
@@ -11,18 +11,19 @@
                libchewing3-dev,
                libhunspell-dev,
                libpinyin-common-dev,
-               libpinyin13-dev,
+               libpinyin15-dev,
                libpresage-dev,
                maliit-framework-dev,
                qml-module-qtquick2,
                qtdeclarative5-dev,
                qtfeedback5-dev,
+               qtquickcontrols2-5-dev,
                qtmultimedia5-dev,
                sqlite3,
                presage,
                xauth,
                xvfb,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/maliit/keyboard
 Vcs-Browser: https://salsa.debian.org/debian/maliit-keyboard
 Vcs-Git: https://salsa.debian.org/debian/maliit-keyboard.git
@@ -30,7 +31,19 @@
 
 Package: maliit-keyboard
 Architecture: any
-Depends: maliit-framework, ${misc:Depends}, ${shlibs:Depends}
+Depends: maliit-framework (>= 2.3.0),
+         fonts-noto,
+         fonts-noto-color-emoji,
+         qml-module-qtgraphicaleffects,
+         qml-module-qtquick2,
+         qml-module-qtquick-controls2,
+         qml-module-qtquick-layouts,
+         ${misc:Depends},
+         ${shlibs:Depends},
+Recommends: hunspell-de-de,
+            hunspell-en-us,
+            hunspell-fr,
+            hunspell-nl,
 Description: virtual on-screen keyboard based on the Maliit Framework
  Maliit Keyboard is a virtual keyboard for Linux systems with Wayland and
  X11 display servers. It supports many different languages and emoji. It

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -Denable-tests=ON

override_dh_install:
	# drop extra license files from bin:pkg
	rm debian/maliit-keyboard/usr/share/doc/maliit-keyboard/COPYING*

	# finally, run dh_install
	dh_install

	# ship the key-press-feedback sound file
	mkdir -p debian/maliit-keyboard/usr/share/maliit/keyboard2/sounds/
	cp debian/sound/key_tick2_quiet.wav debian/maliit-keyboard/usr/share/maliit/keyboard2/sounds/

override_dh_auto_test:
	xvfb-run dh_auto_test

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://github.com/maliit/keyboard/tags /maliit/keyboard/archive/refs/tags/(\d\S*).tar.gz

## maliit-keyboard 2.3.1+p22.04+vrelease+git20240926.0340

=== debian/changelog ===
maliit-keyboard (2.3.1+p22.04+vrelease+git20240926.0340-0) jammy; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 26 Sep 2024 03:40:23 +0000

maliit-keyboard (2.3.1-0neon) jammy; urgency=medium

  [ Jonathan Riddell ]
  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Mon, 16 Jan 2023 19:09:26 +1000

=== debian/control ===
Source: maliit-keyboard
Section: libs
Priority: optional
XSBC-Original-Maintainer: Debian Mobile Team <debian-mobile@lists.debian.org>
Uploaders: Michał Zając <quintasan@kubuntu.org>, Iain Lane <laney@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               libanthy-dev,
               libchewing3-dev,
               libhunspell-dev,
               libpinyin-common-dev,
               libpinyin15-dev,
               libpresage-dev,
               libqt5gstreamer-dev,
               maliit-framework-dev,
               presage,
               qtdeclarative5-dev,
               qtfeedback5-dev,
               qtmultimedia5-dev,
               qtquickcontrols2-5-dev,
               sqlite3
Standards-Version: 4.6.2
Homepage: https://github.com/maliit/keyboard
Vcs-Git: https://invent.kde.org/neon/neon-packaging/maliit-keyboard.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/maliit-keyboard
Maintainer: Neon CI <neon@kde.org>

Package: maliit-keyboard
Architecture: any
Depends: maliit-framework,
         qml-module-qtfeedback,
         qml-module-qtgstreamer,
         qml-module-qtmultimedia,
         qml-module-qtquick-controls2,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Maliit Keyboard
 Keyboard for Maliit

## maliit-keyboard 2.3.1+p24.04+vrelease+git20240927.0430

=== debian/changelog ===
maliit-keyboard (2.3.1+p24.04+vrelease+git20240927.0430-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 27 Sep 2024 04:30:31 +0000

maliit-keyboard (2.3.1-0neon) noble; urgency=medium

  [ Jonathan Riddell ]
  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Mon, 16 Jan 2023 19:09:26 +1000

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,9 @@
                debhelper-compat (= 13),
                doxygen,
                libanthy-dev,
+               libanthy-unicode-dev,
+               libanthyinput-dev,
+               libanthyinput-unicode-dev,
                libchewing3-dev,
                libhunspell-dev,
                libpinyin-common-dev,
@@ -28,13 +31,23 @@
 
 Package: maliit-keyboard
 Architecture: any
-Depends: maliit-framework,
-         qml-module-qtfeedback,
+Depends: qml-module-qtfeedback,
+         qml-module-qtgraphicaleffects,
          qml-module-qtgstreamer,
          qml-module-qtmultimedia,
          qml-module-qtquick-controls2,
+         qml-module-qtquick-layouts,
+         qml-module-qtquick-localstorage,
          qml-module-qtquick2,
          ${misc:Depends},
          ${shlibs:Depends}
-Description: Maliit Keyboard
- Keyboard for Maliit
+Recommends: hunspell-de-de, hunspell-en-us, hunspell-fr, hunspell-nl
+Description: virtual on-screen keyboard based on the Maliit Framework
+ Maliit Keyboard is a virtual keyboard for Linux systems with Wayland and
+ X11 display servers. It supports many different languages and emoji. It
+ is implemented as a plug-in for Maliit Framework.
+ .
+ Maliit Keyboard evolved from the reference keyboard plug-in, Ubuntu
+ Keyboard and Lomiri Keyboard. Ubuntu Keyboard was a fork of the
+ reference plugin which was taking into account the special UI/UX needs
+ of Ubuntu Phone.

## maliit-keyboard 2.3.1+p24.04+vrelease+git20250831.2310

=== debian/changelog ===
maliit-keyboard (2.3.1+p24.04+vrelease+git20250831.2310-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 31 Aug 2025 23:10:33 +0000

## maliit-keyboard 2.3.1+p24.04+vstable+git20250831.2312

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,6 @@
 
 project(maliit-keyboard VERSION 2.3.1)
 
-option(enable-presage "Use presage to calculate word candidates (maliit-keyboard-plugin only)" ON)
 option(enable-hunspell "Use hunspell for error correction (maliit-keyboard-plugin only)" ON)
 option(enable-tests "Build tests" ON)
 
@@ -76,6 +75,8 @@
 set(WESTERNSUPPORT_SOURCES
         plugins/westernsupport/spellchecker.cpp
         plugins/westernsupport/spellchecker.h
+        plugins/westernsupport/spellpredictworker.cpp
+        plugins/westernsupport/spellpredictworker.h
         plugins/westernsupport/westernlanguagefeatures.cpp
         plugins/westernsupport/westernlanguagefeatures.h
         plugins/westernsupport/westernlanguagesplugin.cpp
@@ -95,24 +96,6 @@
         MALIIT_KEYBOARD_DATA_DIR="${CMAKE_INSTALL_PREFIX}/${MALIIT_KEYBOARD_DATA_DIR}"
         MALIIT_KEYBOARD_LANGUAGES_DIR="${CMAKE_INSTALL_PREFIX}/${MALIIT_KEYBOARD_LANGUAGES_DIR}")
 set(maliit-keyboard-include-dirs)
-
-if(enable-presage)
-    # Presage headers incompatible with C++17, which is default in newer GCC
-    set(CMAKE_CXX_STANDARD 14)
-    find_package(Presage REQUIRED)
-
-    if(Presage_FOUND)
-        list(APPEND maliit-keyboard-definitions HAVE_PRESAGE)
-        list(APPEND maliit-keyboard-libraries ${Presage_LIBRARIES})
-        list(APPEND maliit-keyboard-include-dirs ${Presage_INCLUDE_DIRS})
-
-        list(APPEND WESTERNSUPPORT_SOURCES
-                plugins/westernsupport/candidatescallback.cpp
-                plugins/westernsupport/candidatescallback.h
-                plugins/westernsupport/spellpredictworker.cpp
-                plugins/westernsupport/spellpredictworker.h)
-    endif()
-endif()
 
 if(enable-hunspell)
     find_package(Hunspell REQUIRED)
@@ -203,7 +186,7 @@
 target_include_directories(westernsupport PUBLIC src/lib/logic plugins/westernsupport ${maliit-keyboard-include-dirs})
 target_compile_definitions(westernsupport PRIVATE ${maliit-keyboard-definitions})
 
-function(language_plugin _language _full_language _ebook)
+function(language_plugin _language _full_language)
     # To support layout style variations such as en@dv we need to avoid using
     # the @ character in variables, so split and replace it with _
     set(_target ${_language})
@@ -214,10 +197,6 @@
     set(PLUGIN_SOURCES
             plugins/${_language}/src/${_full_language}plugin.h
             plugins/${_language}/src/${_full_language}plugin.json)
-if(enable-presage)
-    add_ngram(TEXT plugins/${_language}/src/${_ebook} DATABASE database_${_language}.db)
-    list(APPEND PLUGIN_SOURCES database_${_language}.db)
-endif()
     add_library(${_target}plugin MODULE ${PLUGIN_SOURCES})
     set_target_properties(${_target}plugin PROPERTIES OUTPUT_NAME ${_language}plugin)
     target_link_libraries(${_target}plugin maliit-keyboard-common westernsupport)
@@ -228,10 +207,6 @@
             DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
     install(TARGETS ${_target}plugin
             LIBRARY DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
-if(enable-presage)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/database_${_language}.db
-            DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
-endif()
     foreach(_file IN LISTS ARGN)
         install(FILES plugins/${_language}/${_file}
                 DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
@@ -240,7 +215,7 @@
 
 function(abstract_language_plugin _language _full_language)
     set(options ABSTRACT_LANGUAGE_PLUGIN)
-    set(oneValueArgs NGRAM_DATABASE PLUGIN_DIR LANGUAGE_FEATURES)
+    set(oneValueArgs PLUGIN_DIR LANGUAGE_FEATURES)
     set(multiValueArgs SOURCES LIBRARIES INCLUDE_DIRS DEFINITIONS FILES DIRECTORY)
     cmake_parse_arguments(abstract_language_plugin "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
 
@@ -273,3 +248,18 @@
     endif()
     if(abstract_language_plugin_ABSTRACT_LANGUAGE_PLUGIN)
         list(APPEND PLUGIN_SOURCES
+                src/lib/logic/abstractlanguageplugin.cpp
+                src/lib/logic/abstractlanguageplugin.h)
+    endif()
+    foreach(_s IN LISTS abstract_language_plugin_SOURCES)
+        list(APPEND PLUGIN_SOURCES plugins/${_plugindir}/src/${_s})
+    endforeach()
+    add_library(${_target}plugin MODULE ${PLUGIN_SOURCES})
+    set_target_properties(${_target}plugin PROPERTIES OUTPUT_NAME ${_language}plugin)
+    target_link_libraries(${_target}plugin Qt5::Core Maliit::Plugins maliit-keyboard-common ${abstract_language_plugin_LIBRARIES})
+    target_include_directories(${_target}plugin PRIVATE src/lib/logic ${abstract_language_plugin_INCLUDE_DIRS})
+    target_compile_definitions(${_target}plugin PRIVATE ${abstract_language_plugin_DEFINITIONS})
+    install(TARGETS ${_target}plugin
+            LIBRARY DESTINATION ${MALIIT_KEYBOARD_LANGUAGES_DIR}/${_language})
+    install(FILES plugins/${_plugindir}/qml/Keyboard_${_language}.qml
+            plugins/${_plugindir}/qml/Keyboard_${_language}_email.qml

=== debian/changelog ===
maliit-keyboard (2.3.1+p24.04+vstable+git20250831.2312-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 31 Aug 2025 23:12:29 +0000

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,8 @@
 
 Package: maliit-keyboard
 Architecture: any
-Depends: qml-module-qtfeedback,
+Depends: maliit-framework,
+         qml-module-qtfeedback,
          qml-module-qtgraphicaleffects,
          qml-module-qtgstreamer,
          qml-module-qtmultimedia,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=-DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_PREFIX_PATH=/usr -DCMAKE_INSTALL_PREFIX=/usr

override_dh_auto_test:
	true

## maliit-keyboard 2.3.1+p24.04+vunstable+git20250831.2315

=== debian/changelog ===
maliit-keyboard (2.3.1+p24.04+vunstable+git20250831.2315-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 31 Aug 2025 23:15:07 +0000
